#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCNumberPort.h"
#import "QCColorPort.h"

@interface GLQuadPatch : QCPatch
{
	QCNumberPort	*inputX1;
	QCNumberPort	*inputY1;
	QCNumberPort	*inputZ1;
	QCColorPort		*inputColor1;

	QCNumberPort	*inputX2;
	QCNumberPort	*inputY2;
	QCNumberPort	*inputZ2;
	QCColorPort		*inputColor2;

	QCNumberPort	*inputX3;
	QCNumberPort	*inputY3;
	QCNumberPort	*inputZ3;
	QCColorPort		*inputColor3;
	
	QCNumberPort	*inputX4;
	QCNumberPort	*inputY4;
	QCNumberPort	*inputZ4;
	QCColorPort		*inputColor4;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;
- (id)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end