#import <OpenGL/gl.h>
#import <OpenGL/OpenGL.h>

#import "GLQuadPatch.h"


@implementation GLQuadPatch : QCPatch

+ (int)executionMode
{
	return 1;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	if(z)
	{
		[inputX1 setDoubleValue:-0.5];
		[inputY1 setDoubleValue:-0.5];
		
		[inputX2 setDoubleValue: 0.5];
		[inputY2 setDoubleValue:-0.5];
		
		[inputX3 setDoubleValue: 0.5];
		[inputY3 setDoubleValue: 0.5];
		
		[inputX4 setDoubleValue:-0.5];
		[inputY4 setDoubleValue: 0.5];
		
		[inputColor1 setRed:0.7 green:0.4 blue:0.4 alpha:0.7];
		[inputColor2 setRed:0.4 green:0.7 blue:0.4 alpha:0.7];
		[inputColor3 setRed:0.4 green:0.4 blue:0.7 alpha:0.7];
		[inputColor4 setRed:0.9 green:0.9 blue:0.9 alpha:0.7];
	}
	return z;
}
- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Quad" forKey:@"name"];
	return at;
}


- (id)setup:(QCOpenGLContext *)context
{
	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{
}


- (void)enable:(QCOpenGLContext *)context
{
}
- (void)disable:(QCOpenGLContext *)context
{
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	float red1,green1,blue1,alpha1;
	float red2,green2,blue2,alpha2;
	float red3,green3,blue3,alpha3;
	float red4,green4,blue4,alpha4;
	
	[inputColor1 getRed:&red1 green:&green1 blue:&blue1 alpha:&alpha1];
	[inputColor2 getRed:&red2 green:&green2 blue:&blue2 alpha:&alpha2];
	[inputColor3 getRed:&red3 green:&green3 blue:&blue3 alpha:&alpha3];
	[inputColor4 getRed:&red4 green:&green4 blue:&blue4 alpha:&alpha4];
	
	CGLSetCurrentContext([context CGLContextObj]);
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_POLYGON_SMOOTH);	// this doesn't appear to work on my MacBook :(
	glHint(GL_POLYGON_SMOOTH_HINT,GL_NICEST);
	
	glBegin(GL_QUADS);
		glColor4f(red1,green1,blue1,alpha1);
		glVertex3f([inputX1 doubleValue],[inputY1 doubleValue],[inputZ1 doubleValue]);
		glColor4f(red2,green2,blue2,alpha2);
		glVertex3f([inputX2 doubleValue],[inputY2 doubleValue],[inputZ2 doubleValue]);
		glColor4f(red3,green3,blue3,alpha3);
		glVertex3f([inputX3 doubleValue],[inputY3 doubleValue],[inputZ3 doubleValue]);
		glColor4f(red4,green4,blue4,alpha4);
		glVertex3f([inputX4 doubleValue],[inputY4 doubleValue],[inputZ4 doubleValue]);
	glEnd();

	return YES;
}

@end
