#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCNumberPort.h"
#import "QCIndexPort.h"
#import "QCColorPort.h"

@interface GLSplinePatch : QCPatch
{
	QCIndexPort		*inputSubdivisions;
	QCNumberPort	*inputTension;
	QCNumberPort	*inputWidth;
	QCBooleanPort	*inputShowPoints;
	
	QCNumberPort	**xArray;
	QCNumberPort	**yArray;
	QCNumberPort	**zArray;
	QCColorPort		**colorArray;
	
	unsigned int controlPoints;
	double *ptsx, *ptsy, *ptsz;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;
- (id)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;

- (NSDictionary*)state;
- (BOOL)setState:(NSDictionary*)state;

- (void)addPoint;
- (void)removePoint;
@end